; Generic assembly routines

.386p
.MODEL FLAT

	PUBLIC _ASM_DivU64To32
	PUBLIC _ASM_DivS64To32
	PUBLIC _ASM_FastCopy8
	PUBLIC _ASM_FastFill8
	PUBLIC _ASM_FastCopy16
	PUBLIC _ASM_FastFill16
	PUBLIC _ASM_FastCopy32
	PUBLIC _ASM_FastFill32

.CODE
	; Input:
	;  EDX:EAX = 64-bit dividend
	;  EBX = 32-bit divisor
	;
	; Output:
	;  EAX = result
	ALIGN 4
_ASM_DivU64To32 PROC NEAR
	push edx
	div ebx
	pop edx
	retn
_ASM_DivU64To32 ENDP

	; Input:
	;  EDX:EAX = 64-bit dividend
	;  EBX = 32-bit divisor
	;
	; Output:
	;  EAX = result
	ALIGN 4
_ASM_DivS64To32 PROC NEAR
	push edx
	idiv ebx
	pop edx
	retn
_ASM_DivS64To32 ENDP

	; Input:
	;  ESI = Pointer to source
	;  EDI = Pointer to destination
	;  ECX = BYTEs to copy
	ALIGN 4
_ASM_FastCopy8 PROC NEAR
	push ecx
	push esi
	push edi
	; ------------------
	cld
	rep movsb
	; ------------------
	pop edi
	pop esi
	pop ecx
	retn
_ASM_FastCopy8 ENDP

	; Input:
	;  EDI = Pointer to data
	;  EAX = BYTE value
	;  ECX = BYTEs to fill
	ALIGN 4
_ASM_FastFill8 PROC NEAR
	push ecx
	push edi
	; ------------------
	cld
	rep stosb
	; ------------------
	pop edi
	pop ecx
	retn
_ASM_FastFill8 ENDP

	; Input:
	;  ESI = Pointer to source
	;  EDI = Pointer to destination
	;  ECX = WORDs to copy
	ALIGN 4
_ASM_FastCopy16 PROC NEAR
	push ecx
	push esi
	push edi
	; ------------------
	cld
	rep movsw
	; ------------------
	pop edi
	pop esi
	pop ecx
	retn
_ASM_FastCopy16 ENDP

	; Input:
	;  EDI = Pointer to data
	;  EAX = WORD value
	;  ECX = WORDs to fill
	ALIGN 4
_ASM_FastFill16 PROC NEAR
	push ecx
	push edi
	; ------------------
	cld
	rep stosw
	; ------------------
	pop edi
	pop ecx
	retn
_ASM_FastFill16 ENDP

	; Input:
	;  ESI = Pointer to source
	;  EDI = Pointer to destination
	;  ECX = DWORDs to copy
	ALIGN 4
_ASM_FastCopy32 PROC NEAR
	push ecx
	push esi
	push edi
	; ------------------
	cld
	rep movsd
	; ------------------
	pop edi
	pop esi
	pop ecx
	retn
_ASM_FastCopy32 ENDP

	; Input:
	;  EDI = Pointer to data
	;  EAX = DWORD value
	;  ECX = DWORDs to fill
	ALIGN 4
_ASM_FastFill32 PROC NEAR
	push ecx
	push edi
	; ------------------
	cld
	rep stosd
	; ------------------
	pop edi
	pop ecx
	retn
_ASM_FastFill32 ENDP

END
