.386p
.MODEL FLAT

	INCLUDE "hardware/avideo.i"
	INCLUDE "gfx/afont.i"

ROW_TEXT_X	EQU 8
TOP_ROWS_Y 	EQU 139
MID_ROW_TEXT_Y	EQU 182
VISIBLE_ROWS	EQU 13

	; drawcode.c
	EXTERN _noteDrawRoutines:DWORD
	EXTERN _twoHexDrawRoutines:DWORD
	EXTERN _oneHexDrawRoutines:DWORD
	EXTERN _rowDrawRoutines:DWORD
	EXTERN _bigNoteDrawRoutines:DWORD
	EXTERN _bigTwoHexDrawRoutines:DWORD
	EXTERN _bigOneHexDrawRoutines:DWORD
	EXTERN _bigRowDrawRoutines:DWORD
	EXTERN _oldPatternRows:DWORD

	PUBLIC _Pattern_ClearRows
	PUBLIC _Pattern_DrawRows

.CODE

ERASE_ROW_LINE MACRO
	; row number
	mov [esi+1],dx	; (unaligned word is still faster than byte pair)

	; channel 1
	mov [esi+4],edx
	mov [esi+8],edx

	; channel 2
	mov [esi+13],dl ; align first (unaligned dword = slow)
	mov [esi+14],edx
	mov [esi+18],dx
	mov [esi+20],dl

	; channel 3
	mov [esi+22],edx
	mov [esi+26],edx

	; channel 4
	mov [esi+31],dl ; align first (unaligned dword = slow)
	mov [esi+32],edx
	mov [esi+36],dx
	mov [esi+38],dl
ENDM

	; Input:
	;  EAX = Start row
	;  ECX = Number of rows
	ALIGN 4
_Pattern_ClearRows PROC NEAR
	pushad
	; -------------------------------------
	mov ebp,ecx
	shl ecx,4
	; -------------------------------------
	mov edx,_oldPatternRows
	mov ebx,eax
	shl ebx,6
	lea edi,[edx+ebx]
	; -------------------------------------	
	mov esi,VGA_FRAMEBUFFER+(TOP_ROWS_Y*(SCREEN_W/8))
	imul ebx,eax,(FONT_H+2)*(SCREEN_W/8)
	add esi,ebx
	; -------------------------------------
	cmp eax,6
	jb OK0
	; -------------------------------------
	; skip middle row (current row)
	add esi,((FONT_H)+2)*(SCREEN_W/8)
OK0:	; -------------------------------------
	mov eax,SCREEN_W/8
	xor edx,edx
Loop0:	; -------------------------------------
	; 5x unroll (FONT_H)
	ERASE_ROW_LINE
	add esi,eax
	ERASE_ROW_LINE
	add esi,eax
	ERASE_ROW_LINE
	add esi,eax
	ERASE_ROW_LINE
	add esi,eax
	ERASE_ROW_LINE
	add esi,(SCREEN_W/8)*3
	; -------------------------------------
	dec ebp
	jnz Loop0
	; -------------------------------------
	; clear "last drawn entries" cache
	mov eax,0FFFFFFFFh
	cld
	rep stosd
	; -------------------------------------
	popad
	retn
_Pattern_ClearRows ENDP

	; Input:
	;  EAX = End row
	;  EBX = Draw row
	;  ECX = Start row
	;  ESI = Pattern data at current position
	ALIGN 4
_Pattern_DrawRows PROC NEAR
	pushad
	mov ebp,eax
	; --------------------------------------------------
	imul eax,ecx,(FONT_H+2)*(SCREEN_W/8)
	mov edi,VGA_FRAMEBUFFER+((TOP_ROWS_Y*(SCREEN_W/8))+(ROW_TEXT_X/8))
	add edi,eax
	; --------------------------------------------------
	mov edx,ecx
	; --------------------------------------------------
	mov eax,_oldPatternRows
	shl ecx,6
	lea ecx,[eax+ecx]
	cld
Loop1:	; --------------------------------------------------
	cmp dl,6	; row to print == current replayer row?
	je MidRow

	; --------------------------------------------------
	; Normal rows, normal font
	; --------------------------------------------------
	mov eax,ebx	; also clears upper bytes of eax
	call dword ptr [_rowDrawRoutines+eax*4]
	add edi,2+1
	; --------------------------------------------------
	; channel 1
	lodsb		; read pattern byte
	cmp eax,[ecx+0]	; does this entry differ from what we have drawn?
	je L00		; nope, skip drawing of this entry
	mov [ecx+0],eax ; store what we drew into the "drawn" buffer
	call dword ptr [_noteDrawRoutines+eax*4]
L00:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+4]
	je L01
	mov [ecx+4],eax
	call dword ptr [_twoHexDrawRoutines+eax*4]
L01:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+8]
	je L02
	mov [ecx+8],eax
	call dword ptr [_oneHexDrawRoutines+eax*4]
L02:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+12]
	je L03
	mov [ecx+12],eax
	call dword ptr [_twoHexDrawRoutines+eax*4]
L03:	add edi,2+1
	; --------------------------------------------------
	; channel 2
	lodsb
	cmp eax,[ecx+16]
	je L04
	mov [ecx+16],eax
	call dword ptr [_noteDrawRoutines+eax*4]
L04:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+20]
	je L05
	mov [ecx+20],eax
	call dword ptr [_twoHexDrawRoutines+eax*4]
L05:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+24]
	je L06
	mov [ecx+24],eax
	call dword ptr [_oneHexDrawRoutines+eax*4]
L06:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+28]
	je L07
	call dword ptr [_twoHexDrawRoutines+eax*4]
	mov [ecx+28],eax
L07:	add edi,2+1
	; --------------------------------------------------
	; channel 3
	lodsb
	cmp eax,[ecx+32]
	je L08
	mov [ecx+32],eax
	call dword ptr [_noteDrawRoutines+eax*4]
L08:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+36]
	je L09
	mov [ecx+36],eax
	call dword ptr [_twoHexDrawRoutines+eax*4]
L09:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+40]
	je L10
	mov [ecx+40],eax
	call dword ptr [_oneHexDrawRoutines+eax*4]
L10:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+44]
	je L11
	mov [ecx+44],eax
	call dword ptr [_twoHexDrawRoutines+eax*4]
L11:	add edi,2+1
	; --------------------------------------------------
	; channel 4
	lodsb
	cmp eax,[ecx+48]
	je L12
	mov [ecx+48],eax
	call dword ptr [_noteDrawRoutines+eax*4]
L12:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+52]
	je L13
	mov [ecx+52],eax
	call dword ptr [_twoHexDrawRoutines+eax*4]
L13:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+56]
	je L14
	mov [ecx+56],eax
	call dword ptr [_oneHexDrawRoutines+eax*4]
L14:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+60]
	je L15
	mov [ecx+60],eax
	call dword ptr [_twoHexDrawRoutines+eax*4]
L15:	add edi,4+((FONT_H+1)*(SCREEN_W/8))
	; --------------------------------------------------
LNext: 	add ecx,4*4*4
	inc ebx
	inc edx
	cmp ebx,ebp
	jne Loop1
	; --------------------------------------------------
	popad
	retn


	; --------------------------------------------------
	; Middle row (current row), big font
	; --------------------------------------------------
MidRow:
	; change bitplane
	push edx
	mov ax,0402h
	mov dx,3C4h
	out dx,ax
	pop edx
	; --------------------------------------------------
	add edi,1*(SCREEN_W/8)
	; --------------------------------------------------
	mov eax,ebx	; also clears upper bytes of eax
	call dword ptr [_bigRowDrawRoutines+eax*4]
	add edi,2+1
	; --------------------------------------------------
	; channel 1
	lodsb		; read pattern byte
	cmp eax,[ecx+0]	; does this entry differ from what we have drawn?
	je L00B		; nope, skip drawing of this entry
	mov [ecx+0],eax ; store what we drew into the "drawn" buffer
	call dword ptr [_bigNoteDrawRoutines+eax*4]
L00B:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+4]
	je L01B
	mov [ecx+4],eax
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
L01B:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+8]
	je L02B
	mov [ecx+8],eax
	call dword ptr [_bigOneHexDrawRoutines+eax*4]
L02B:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+12]
	je L03B
	mov [ecx+12],eax
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
L03B:	add edi,2+1
	; --------------------------------------------------
	; channel 2
	lodsb
	cmp eax,[ecx+16]
	je L04B
	mov [ecx+16],eax
	call dword ptr [_bigNoteDrawRoutines+eax*4]
L04B:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+20]
	je L05B
	mov [ecx+20],eax
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
L05B:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+24]
	je L06B
	mov [ecx+24],eax
	call dword ptr [_bigOneHexDrawRoutines+eax*4]
L06B:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+28]
	je L07B
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
	mov [ecx+28],eax
L07B:	add edi,2+1
	; --------------------------------------------------
	; channel 3
	lodsb
	cmp eax,[ecx+32]
	je L08B
	mov [ecx+32],eax
	call dword ptr [_bigNoteDrawRoutines+eax*4]
L08B:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+36]
	je L09B
	mov [ecx+36],eax
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
L09B:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+40]
	je L10B
	mov [ecx+40],eax
	call dword ptr [_bigOneHexDrawRoutines+eax*4]
L10B:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+44]
	je L11B
	mov [ecx+44],eax
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
L11B:	add edi,2+1
	; --------------------------------------------------
	; channel 4
	lodsb
	cmp eax,[ecx+48]
	je L12B
	mov [ecx+48],eax
	call dword ptr [_bigNoteDrawRoutines+eax*4]
L12B:	add edi,3
	; ----------
	lodsb
	cmp eax,[ecx+52]
	je L13B
	mov [ecx+52],eax
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
L13B:	add edi,2
	; ----------
	lodsb
	cmp eax,[ecx+56]
	je L14B
	mov [ecx+56],eax
	call dword ptr [_bigOneHexDrawRoutines+eax*4]
L14B:	inc edi
	; ----------
	lodsb
	cmp eax,[ecx+60]
	je L15B
	mov [ecx+60],eax
	call dword ptr [_bigTwoHexDrawRoutines+eax*4]
L15B:	; --------------------------------------------------
	; set back bitplane
	push edx
	mov ax,0702h
	mov dx,3C4h
	out dx,ax
	pop edx
	; --------------------------------------------------
	add edi,4+(12*(SCREEN_W/8))
	jmp LNext

_Pattern_DrawRows ENDP

END
