// generic assembly routines

#ifndef __ASM_H__
#define __ASM_H__

// aasm.asm

extern uint32_t ASM_DivU64To32(uint64_t dividend, uint32_t divisor);
#pragma aux ASM_DivU64To32 parm [EDX EAX] [EBX] value [EAX]

extern int32_t ASM_DivS64To32(uint64_t dividend, uint32_t divisor);
#pragma aux ASM_DivS64To32 parm [EDX EAX] [EBX] value [EAX]

extern void ASM_FastCopy8(void *src, void *dst, uint32_t num);
#pragma aux ASM_FastCopy8 parm [ESI] [EDI] [ECX];

extern void ASM_FastFill8(void *ptr, uint8_t value, uint32_t num);
#pragma aux ASM_FastFill8 parm [EDI] [EAX] [ECX];

extern void ASM_FastCopy16(void *src, void *dst, uint32_t num);
#pragma aux ASM_FastCopy16 parm [ESI] [EDI] [ECX];

extern void ASM_FastFill16(void *ptr, uint16_t value, uint32_t num);
#pragma aux ASM_FastFill16 parm [EDI] [EAX] [ECX];

extern void ASM_FastCopy32(void *src, void *dst, uint32_t num);
#pragma aux ASM_FastCopy32 parm [ESI] [EDI] [ECX];

extern void ASM_FastFill32(void *ptr, uint32_t value, uint32_t num);
#pragma aux ASM_FastFill32 parm [EDI] [EAX] [ECX];

#endif
