#ifndef __AUDIO_H__
#define __AUDIO_H__

#include <stdint.h>
#include <stdbool.h>

#define AUDIO_BUF_SIZE 8192
#define DEF_STEREO_SEP 30 /* percentage, in steps of 10 */

// do NOT change this! If so, change offsets on top of apitint.asm
typedef struct
{
	volatile bool soundReady;
	void *dmaBuffer;
	uint8_t sampleShift, dmaNum;
	int8_t defStereoSep;
	double dOutputFreq;
} audio_t;

// audio.c

extern bool audio16Bit, stereoAudio, audioOpen, audioAmiga500;
extern int8_t stereoSeparation;
extern audio_t audio;

// aaudio.asm

extern void Audio_MixSamplesDummy(uint32_t numSamples);
#pragma aux Audio_MixSamplesDummy parm [EDX];

extern void Audio_MixSamples(void *dmaBuffer, uint32_t dmaPosition, uint32_t numSamples);
#pragma aux Audio_MixSamples parm [EDI] [EAX] [EDX];

void Audio_UpdateStereoSeparation(void);
void Audio_SetSamplesPerTick(int64_t samples);
void Audio_ClearSampleCounter(void);
void Audio_ClearLpFilterState(void);
bool Audio_Detect(bool noSound);
bool Audio_Init(void);
bool Audio_StartDMA(void);
void Audio_Close(void);

#endif
