; Optimized planar font routines.
; X position is limited to blocks of 8.

.386p
.MODEL FLAT

	INCLUDE "afont.i"
	INCLUDE "../hardware/avideo.i"

	PUBLIC _Font_GetData
	PUBLIC _Font_Print
	PUBLIC _Font_PrintChar
	PUBLIC _Font_Print2Dec
	PUBLIC _Font_Print3Dec	
	PUBLIC _Font_PrintHexByte
	PUBLIC _Font_PrintHexWord

.CODE
	; Output:
	;  EAX = font data pointer
	ALIGN 4
_Font_GetData PROC NEAR
	lea eax,FontData
	retn
_Font_GetData ENDP

	; Input:
	;  EAX = X position (must be a multiple of 8)
	;  EBX = Y position
	;  ECX = ANSI NUL-terminated string
	ALIGN 4
_Font_Print PROC NEAR
	pushad
	;------------------------------
	; ebx *= 40 (SCREEN_W/8)
	shl ebx,3
	lea ebx,[ebx+ebx*4]
	shr eax,3 ; eax /= 8
	lea edi,[VGA_FRAMEBUFFER+eax+ebx] ; set up framebuffer pointer (from x/y)
	;------------------------------
	lea edx,CharConvTab
	mov ebp,(SCREEN_W/8)-(FONT_W/8)
	mov ebx,(SCREEN_W/8)*(FONT_H-1)
	xor eax,eax
	cld
	;------------------------------
TLoop:	mov al,[ecx]			; al = current string character
	test eax,eax			; NUL?
	jz TEnd				; end of string reached
	inc ecx
	;------------------------------
	mov esi,[edx+eax*4]
	;------------------------------
	; 5x unroll (FONT_H)
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	;------------------------------
	sub edi,ebx
	jmp TLoop
	;------------------------------
TEnd:	popad
	retn
_Font_Print ENDP

	; Input:
	;  EAX = X position
	;  EBX = Y position
	;  ECX = ANSI character
	ALIGN 4
_Font_PrintChar PROC NEAR
	pushad
	;------------------------------
	movzx ecx,cl
	;------------------------------
	; ebx *= 40 (SCREEN_W/8)
	shl ebx,3
	lea ebx,[ebx+ebx*4]
	shr eax,3 ; eax /= 8
	lea edi,[VGA_FRAMEBUFFER+eax+ebx] ; set up framebuffer pointer (from x/y)
	;------------------------------
	mov edx,(SCREEN_W/8)-(FONT_W/8)
	;------------------------------
	mov esi,[CharConvTab+ecx*4]
	cld
	;------------------------------
	; 5x unroll (FONT_H)
	;------------------------------
	movsb
	add edi,edx
	movsb
	add edi,edx
	movsb
	add edi,edx
	movsb
	add edi,edx
	movsb
	;------------------------------
	popad
	retn
_Font_PrintChar ENDP

	; Input:
	;  EAX = X position
	;  EBX = Y position
	;  ECX = value (0..99)
	ALIGN 4
_Font_Print2Dec PROC NEAR
	pushad
	;------------------------------
	movzx ecx,cl
	cmp ecx,99
	ja TooHigh
L0:	lea ecx,[Dec2Tab+ecx*2]
	;------------------------------
	; ebx *= 40 (SCREEN_W/8)
	shl ebx,3
	lea ebx,[ebx+ebx*4]
	shr eax,3 ; eax /= 8
	lea edi,[VGA_FRAMEBUFFER+eax+ebx] ; set up framebuffer pointer (from x/y)
	;------------------------------
	lea edx,CharConvTab
	mov ebp,(SCREEN_W/8)-(FONT_W/8)
	xor eax,eax
	;------------------------------
	mov al,[ecx+0]
	mov esi,[edx+eax*4]
	cld
	;------------------------------
	; 5x unroll (FONT_H)
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	sub edi,(SCREEN_W/8)*(FONT_H-1)
	;------------------------------
	mov al,[ecx+1]
	mov esi,[edx+eax*4]
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	;------------------------------
	popad
	retn
TooHigh:
	mov cl,99
	jmp L0

_Font_Print2Dec ENDP

	; Input:
	;  EAX = X position
	;  EBX = Y position
	;  ECX = value (0..255)
	ALIGN 4
_Font_Print3Dec PROC NEAR
	pushad
	;------------------------------
	movzx ecx,cl
	lea ecx,[Dec3Tab+ecx*4]
	;------------------------------
	; ebx *= 40 (SCREEN_W/8)
	shl ebx,3
	lea ebx,[ebx+ebx*4]
	shr eax,3 ; eax /= 8
	lea edi,[VGA_FRAMEBUFFER+eax+ebx] ; set up framebuffer pointer (from x/y)
	;------------------------------
	lea edx,CharConvTab
	mov ebp,(SCREEN_W/8)-(FONT_W/8)
	mov ebx,(SCREEN_W/8)*(FONT_H-1)
	xor eax,eax
	;------------------------------
	mov al,[ecx+0]
	mov esi,[edx+eax*4]
	cld
	;------------------------------
	; 5x unroll (FONT_H)
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	sub edi,ebx
	;------------------------------
	mov al,[ecx+1]
	mov esi,[edx+eax*4]
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	sub edi,ebx
	;------------------------------
	mov al,[ecx+2]
	mov esi,[edx+eax*4]
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	;------------------------------
	popad
	retn
_Font_Print3Dec ENDP

	; Input:
	;  EAX = X position
	;  EBX = Y position
	;  ECX = hex data
	ALIGN 4
_Font_PrintHexByte PROC NEAR
	pushad
	;------------------------------
	movzx ecx,cl
	;------------------------------
	; ebx *= 40 (SCREEN_W/8)
	shl ebx,3
	lea ebx,[ebx+ebx*4]
	shr eax,3 ; eax /= 8
	lea edi,[VGA_FRAMEBUFFER+eax+ebx] ; set up framebuffer pointer (from x/y)
	;------------------------------
	lea edx,HexConvTab
	mov ebp,(SCREEN_W/8)-(FONT_W/8)
	;------------------------------
	mov eax,ecx
	shr eax,4
	mov esi,[edx+eax*4]
	cld
	;------------------------------
	; 5x unroll (FONT_H)
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	sub edi,(SCREEN_W/8)*(FONT_H-1)
	;------------------------------
	and ecx,15
	mov esi,[edx+ecx*4]
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	;------------------------------
	popad
	retn
_Font_PrintHexByte ENDP

	; Input:
	;  EAX = X position
	;  EBX = Y position
	;  ECX = hex data
	ALIGN 4
_Font_PrintHexWord PROC NEAR
	pushad
	;------------------------------
	movzx ecx,cx
	;------------------------------
	; ebx *= 40 (SCREEN_W/8)
	shl ebx,3
	lea ebx,[ebx+ebx*4]
	shr eax,3 ; eax /= 8
	lea edi,[VGA_FRAMEBUFFER+eax+ebx] ; set up framebuffer pointer (from x/y)
	;------------------------------
	lea edx,HexConvTab
	mov ebp,(SCREEN_W/8)-(FONT_W/8)
	mov ebx,(SCREEN_W/8)*(FONT_H-1)
	;------------------------------
	mov eax,ecx
	shr eax,12
	mov esi,[edx+eax*4]
	cld
	;------------------------------
	; 5x unroll (FONT_H)
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	sub edi,ebx
	;------------------------------
	mov eax,ecx
	shr eax,8
	and eax,15
	mov esi,[edx+eax*4]
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	sub edi,ebx
	;------------------------------
	mov eax,ecx
	shr eax,4
	and eax,15
	mov esi,[edx+eax*4]
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	sub edi,ebx
	;------------------------------
	and ecx,15
	mov esi,[edx+ecx*4]
	;------------------------------
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	add edi,ebp
	movsb
	;------------------------------
	popad
	retn
_Font_PrintHexWord ENDP

.DATA

	ALIGN 4
HexConvTab:
	dd FontData+(('0'-' ')*(FONT_H+1)),FontData+(('1'-' ')*(FONT_H+1))
	dd FontData+(('2'-' ')*(FONT_H+1)),FontData+(('3'-' ')*(FONT_H+1))
	dd FontData+(('4'-' ')*(FONT_H+1)),FontData+(('5'-' ')*(FONT_H+1))
	dd FontData+(('6'-' ')*(FONT_H+1)),FontData+(('7'-' ')*(FONT_H+1))
	dd FontData+(('8'-' ')*(FONT_H+1)),FontData+(('9'-' ')*(FONT_H+1))
	dd FontData+(('A'-' ')*(FONT_H+1)),FontData+(('B'-' ')*(FONT_H+1))
	dd FontData+(('C'-' ')*(FONT_H+1)),FontData+(('D'-' ')*(FONT_H+1))
	dd FontData+(('E'-' ')*(FONT_H+1)),FontData+(('F'-' ')*(FONT_H+1))

	ALIGN 4
CharConvTab:
	; non-implemented glyphs -> space
        REPT 32
		dd FontData
	ENDM
        
        ; actual glyphs
        i=0
	REPT 127-32
		dd FontData+i
		i=i+(FONT_H+1)
	ENDM
	
	; non-implemented glyphs -> space
	REPT 256-(127-32)
		dd FontData
	ENDM

FontData:
	db 0,0,0,0,0,0
	db 24,24,24,0,24,0,102,102,0,0,0,0,108,254,108,254,108,0,126,208,124
	db 22,252,0,102,108,24,54,102,0,48,72,58,68,58,0,12,12,24,0,0,0,12,24
	db 24,24,12,0,24,12,12,12,24,0,68,56,124,56,68,0,16,16,124,16,16,0,0
	db 0,0,12,24,0,0,0,124,0,0,0,0,0,0,24,24,0,6,12,24,48,96,0,60,110,118
	db 102,60,0,24,56,24,24,60,0,124,6,60,96,126,0,124,6,28,6,124,0,28,60
	db 108,126,12,0,126,96,124,6,124,0,62,96,124,102,60,0,126,6,12,24,24
	db 0,60,102,60,102,60,0,60,102,62,6,124,0,24,24,0,24,24,0,24,24,0,24
	db 48,0,12,24,48,24,12,0,0,60,0,60,0,0,48,24,12,24,48,0,124,6,28,0,24
	db 0,60,110,110,96,60,0,60,102,126,102,102,0,124,102,124,102,124,0,60
	db 102,96,102,60,0,124,102,102,102,124,0,126,96,120,96,126,0,126,96
	db 120,96,96,0,62,96,110,102,62,0,102,102,126,102,102,0,60,24,24,24
	db 60,0,126,6,6,102,60,0,102,108,120,108,102,0,96,96,96,96,126,0,66
	db 102,126,102,102,0,102,118,126,110,102,0,60,102,102,102,60,0,124,102
	db 124,96,96,0,60,102,102,108,54,0,124,102,124,108,102,0,62,96,60,6
	db 124,0,126,24,24,24,24,0,102,102,102,102,60,0,102,102,102,60,24,0
	db 102,102,126,102,66,0,102,60,24,60,102,0,102,102,60,24,24,0,126,12
	db 24,48,126,0,60,48,48,48,60,0,96,48,24,12,6,0,60,12,12,12,60,0,16
	db 56,108,68,0,0,0,0,0,0,126,0,48,24,0,0,0,0,60,102,126,102,102,0,124
	db 102,124,102,124,0,60,102,96,102,60,0,124,102,102,102,124,0,126,96
	db 120,96,126,0,126,96,120,96,96,0,62,96,110,102,62,0,102,102,126,102
	db 102,0,60,24,24,24,60,0,126,6,6,102,60,0,102,108,120,108,102,0,96
	db 96,96,96,126,0,66,102,126,102,102,0,102,118,126,110,102,0,60,102
	db 102,102,60,0,124,102,124,96,96,0,60,102,102,108,54,0,124,102,124
	db 108,102,0,62,96,60,6,124,0,126,24,24,24,24,0,102,102,102,102,60,0
	db 102,102,102,60,24,0,102,102,126,102,66,0,102,60,24,60,102,0,102,102
	db 60,24,24,0,126,12,24,48,126,0,28,32,96,32,28,0,24,24,24,24,24,0,56
	db 4,6,4,56,0,59,110,0,0,0

	ALIGN 2
Dec2Tab:
	db "000102030405"
	db "060708091011"
	db "121314151617"
	db "181920212223"
	db "242526272829"
	db "303132333435"
	db "363738394041"
	db "424344454647"
	db "484950515253"
	db "545556575859"
	db "606162636465"
	db "666768697071"
	db "727374757677"
	db "787980818283"
	db "848586878889"
	db "909192939495"
	db "96979899"

	ALIGN 4
Dec3Tab:
	db "000 001 002 003 004 005 006 007 008 009 010 011 "
	db "012 013 014 015 016 017 018 019 020 021 022 023 "
	db "024 025 026 027 028 029 030 031 032 033 034 035 "
	db "036 037 038 039 040 041 042 043 044 045 046 047 "
	db "048 049 050 051 052 053 054 055 056 057 058 059 "
	db "060 061 062 063 064 065 066 067 068 069 070 071 "
	db "072 073 074 075 076 077 078 079 080 081 082 083 "
	db "084 085 086 087 088 089 090 091 092 093 094 095 "
	db "096 097 098 099 100 101 102 103 104 105 106 107 "
	db "108 109 110 111 112 113 114 115 116 117 118 119 "
	db "120 121 122 123 124 125 126 127 128 129 130 131 "
	db "132 133 134 135 136 137 138 139 140 141 142 143 "
	db "144 145 146 147 148 149 150 151 152 153 154 155 "
	db "156 157 158 159 160 161 162 163 164 165 166 167 "
	db "168 169 170 171 172 173 174 175 176 177 178 179 "
	db "180 181 182 183 184 185 186 187 188 189 190 191 "
	db "192 193 194 195 196 197 198 199 200 201 202 203 "
	db "204 205 206 207 208 209 210 211 212 213 214 215 "
	db "216 217 218 219 220 221 222 223 224 225 226 227 "
	db "228 229 230 231 232 233 234 235 236 237 238 239 "
	db "240 241 242 243 244 245 246 247 248 249 250 251 "
	db "252 253 254 255 "

END
