.386p
.MODEL FLAT

	; Interrupt routines for PIT timer chip.
	; Some of this code is partly based on Fasttracker II's code

AUDIO_BUF_SIZE EQU 8192 ; must match the value in audio.h!

	; offsets into audio struct (audio.h)
a_soundReady		EQU 0
a_dmaBuffer		EQU 4
a_sampleShift		EQU 8
a_dmaNum		EQU 9

	EXTERN __GETDS:PROC

	; main.c
	EXTERN _audioStructPtr:DWORD
	
	; audio.c
	EXTERN _Audio_MixSamples:PROC
	EXTERN _Audio_MixSamplesDummy:PROC

	; ui.c
	EXTERN _showRasterBars:BYTE	

	; pit.c
	EXTERN _dmaMixPos:DWORD
	EXTERN _oldInt8VectorDelta:DWORD
	EXTERN _oldInt8VectorFrac:DWORD
	EXTERN _vblankAudioSamples15:DWORD
	EXTERN _vblankAudioSamples25:DWORD	
	EXTERN _oldInt8Vector:PROC

	; dma.c
	EXTERN _DMA_GetPosition:PROC

	; avideo.asm
	EXTERN vblankPitTimeout:DWORD
	EXTERN vblankPitTicks16:WORD	; vblankPitTicks - (vblankPitTicks/16)
	EXTERN vblankPitTicks128:WORD	; vblankPitTicks - (vblankPitTicks/128)
	EXTERN videoFrameTest:BYTE

	; mouse.c
	EXTERN _updateMousePalette:BYTE
	EXTERN _mouseR:BYTE
	EXTERN _mouseG:BYTE
	EXTERN _mouseB:BYTE
	
	; ui.c
	EXTERN _UI_Debug:PROC

	PUBLIC _int8Vector
	PUBLIC _int8VectorNoAudio
	
	
	
.CODE

SET_BG_COLOR MACRO r,g,b
	mov dx,3C8h	
	xor eax,eax
	out dx,al
	inc edx
	mov al,r
	out dx,al
	mov al,g
	out dx,al
	mov al,b
	out dx,al
ENDM

RESTORE_BG_COLOR MACRO
	mov dx,3C8h
	xor eax,eax
	out dx,al
	inc edx
	out dx,al
	out dx,al
	out dx,al
ENDM

	ALIGN 4
_int8Vector PROC NEAR
	pushad
	push ds
	push es
	call __GETDS
	mov ax,ds
	mov es,ax
	; --------------------------------------------
	; If inactive,
	;   wait until end, use: vblankPitTicks1
	; else
	;   use: vblankPitTicks2
	; --------------------------------------------
	mov dx,3DAh
	; --------------------------------------------
	mov ecx,vblankPitTimeout
L00:	in al,dx
	test al,1
	loopnz L00
	jz BelowVBL
	; --------------------------------------------
StillDoingVBL:
	mov ecx,vblankPitTimeout
L01:	in al,dx
	test al,1
	loopnz L01
	jnz StillDoingVBL
	mov cx,vblankPitTicks128	; vblankPitTicks - (vblankPitTicks/128)
	jmp SetPITCount
	; --------------------------------------------
BelowVBL:
	mov cx,vblankPitTicks16		; vblankPitTicks - (vblankPitTicks/16)
	; --------------------------------------------
SetPITCount:
	mov al,36h
	out 43h,al
	mov al,cl
	out 40h,al
	mov al,ch
	out 40h,al
	; --------------------------------------------
	xor eax,eax	; al = 0
	xchg al,_updateMousePalette
	test al,al
	jz L03
	; --------------------------------------------
	; Update mouse palette
	; --------------------------------------------
	mov dx,3C8h
	mov al,16
	out dx,al
	inc edx
	mov ecx,8
L02:	mov al,_mouseR
	out dx,al
	mov al,_mouseG
	out dx,al
	mov al,_mouseB
	out dx,al
	dec ecx
	jnz L02
	; --------------------------------------------
L03:	inc byte ptr videoFrameTest ; for Video_WaitForVblank()
	; --------------------------------------------
	cmp byte ptr _showRasterBars,0
	je L04
	SET_BG_COLOR 63,0,0
L04:	; --------------------------------------------
	; Run old interrupt 8 at old PIT channel 0 rate (18.2Hz)
	; --------------------------------------------
	mov eax,_oldInt8VectorDelta
	add _oldInt8VectorFrac,eax
	jnc L05
	pushfd
	call fword ptr _oldInt8Vector
	jmp L06
L05:	; --------------------------------------------
	; Send EOI to PIC chip #1 (IRQ 0)
	; --------------------------------------------
	mov al,20h
	out 20h,al
L06:	; --------------------------------------------
	mov esi,_audioStructPtr
	cmp byte ptr a_soundReady[esi],1
	jne NoMix
	; --------------------------------------------
	; Get sound DMA position in EBX
	; --------------------------------------------
	push byte ptr a_dmaNum[esi]
	call _DMA_GetPosition ; result --> ax
	add esp,4
	; --------------------------------------------
	movzx ebx,ax
	neg ebx
	mov ebp,AUDIO_BUF_SIZE-1	; copy in ebp
	add ebx,ebp
	; --------------------------------------------
	mov al,1
	xchg al,mixingOngoing
	cmp al,1
	je L07
	; --------------------------------------------
	mov edx,_dmaMixPos
	mov eax,edx		; eax = copy of _dmaMixPos
	sub edx,ebx
	and edx,ebp
	mov cl,a_sampleShift[esi]
	shr edx,cl
	mov ebx,_vblankAudioSamples25
	sub ebx,edx		; ebx = samplesToMix
	jb NoMix
	; --------------------------------------------
	cmp ebx,_vblankAudioSamples15
	ja NoMix
	; --------------------------------------------
	and ebx,0-16		; align to blocks of 16
	jz NoMix
	; --------------------------------------------
	mov edi,a_dmaBuffer[esi]
	mov edx,ebx
	shl edx,cl
	add edx,eax
	and edx,ebp
	mov _dmaMixPos,edx
	call _Audio_MixSamples
	
NoMix:	; --------------------------------------------
	mov byte ptr mixingOngoing,0
	; --------------------------------------------
L07:	cmp byte ptr _showRasterBars,0
	je L08
	RESTORE_BG_COLOR
L08:	; --------------------------------------------
	pop es
	pop ds
	popad
	iretd
_int8Vector ENDP

	ALIGN 4
_int8VectorNoAudio PROC NEAR
	pushad
	push ds
	push es
	call __GETDS
	mov ax,ds
	mov es,ax
	; --------------------------------------------
	; If inactive,
	;   wait until end, use: vblankPitTicks1
	; else
	;   use: vblankPitTicks2
	; --------------------------------------------
	mov dx,3DAh
	; --------------------------------------------
	mov ecx,vblankPitTimeout
L09:	in al,dx
	test al,1
	loopnz L09
	jz BelowVBL2
	; --------------------------------------------
StillDoingVBL2:
	mov ecx,vblankPitTimeout
L10:	in al,dx
	test al,1
	loopnz L10
	jnz StillDoingVBL2
	mov cx,vblankPitTicks128	; vblankPitTicks - (vblankPitTicks/128)
	jmp SetPITCount2
	; --------------------------------------------
BelowVBL2:
	mov cx,vblankPitTicks16		; vblankPitTicks - (vblankPitTicks/16)
	; --------------------------------------------
SetPITCount2:
	mov al,36h
	out 43h,al
	mov al,cl
	out 40h,al
	mov al,ch
	out 40h,al
	; --------------------------------------------	
	xor eax,eax	; al = 0
	xchg al,_updateMousePalette
	test al,al
	jz L12
	; --------------------------------------------
	; Update mouse palette
	; --------------------------------------------
	mov dx,3C8h
	mov al,16
	out dx,al
	inc edx
	mov ecx,8
L11:	mov al,_mouseR
	out dx,al
	mov al,_mouseG
	out dx,al
	mov al,_mouseB
	out dx,al
	dec ecx
	jnz L11
	; --------------------------------------------
L12:	inc byte ptr videoFrameTest ; for Video_WaitForVblank()
	; --------------------------------------------
	cmp byte ptr _showRasterBars,0
	je L13
	SET_BG_COLOR 63,0,0
L13:	; --------------------------------------------
	; Run old interrupt 8 at old PIT channel 0 rate (18.2Hz)
	; --------------------------------------------
	mov eax,_oldInt8VectorDelta
	add _oldInt8VectorFrac,eax
	jnc L14
	pushfd
	call fword ptr _oldInt8Vector
	jmp L15
L14:	; --------------------------------------------
	; Send EOI to PIC chip #1 (IRQ 0)
	; --------------------------------------------
	mov al,20h
	out 20h,al
L15:	; --------------------------------------------
	mov eax,512 ; 2^9 (extra precision)
	call _Audio_MixSamplesDummy
	; --------------------------------------------
	cmp byte ptr _showRasterBars,0
	je L16
	RESTORE_BG_COLOR
L16:	; --------------------------------------------
	pop es
	pop ds
	popad
	iretd
_int8VectorNoAudio ENDP

mixingOngoing: db 0

END
