.386p
.MODEL FLAT

; Some of these routines are based on Fasttracker II's code.
; They have been heavily modified by me.

	; amouse.asm
	EXTERN _Mouse_Update:PROC

	; ui.c
	EXTERN _showRasterBars:BYTE 

	; video.c
	EXTERN _vblankPitTicks:WORD
	EXTERN _vblankPitTimerEnabled:BYTE

	PUBLIC vblankPitTimeout:DWORD
	PUBLIC vblankPitTicks16:WORD
	PUBLIC vblankPitTicks128:WORD
	PUBLIC videoFrameTest:BYTE

	PUBLIC _Video_WaitForVblank
	PUBLIC _Video_MeasureVblankPitTicks

.CODE

; frame wait routines (uses showRasterBars/vblankPitTimerEnabled flags)

	ALIGN 4
waitPitTimerNoRasterBar:
	lea eax,videoFrameTest
	mov dl,[eax]
pnr_L0:	cmp dl,[eax]
	je pnr_L0
	retn

	ALIGN 4	
waitPitTimerRasterBar:
	mov dx,3C8h ; clear raster bar
	xor eax,eax
	out dx,al
	inc edx
	out dx,al
	out dx,al
	out dx,al
	lea eax,videoFrameTest
	mov dl,[eax]
pr_L0:	cmp dl,[eax]
	je pr_L0
	mov dl,0C8h ; show raster bar
	xor eax,eax
	out dx,al
	inc edx
	out dx,al
	mov al,63
	out dx,al
	out dx,al
	retn

	ALIGN 4
waitVblankNoRasterBar:
	mov dx,3DAh ; wait for vblank
vnr_L0:	in al,dx
	test al,8
	jnz vnr_L0
vnr_L1:	in al,dx
	test al,8
	jz vnr_L1
	retn

	ALIGN 4	
waitVblankRasterBar:
	mov dx,3C8h ; clear raster bar
	xor eax,eax
	out dx,al
	inc edx
	out dx,al
	out dx,al
	out dx,al
	mov dl,0DAh ; wait for vblank
vr_L0:	in al,dx
	test al,8
	jnz vr_L0
vr_L1:	in al,dx
	test al,8
	jz vr_L1
	mov dl,0C8h ; show raster bar
	xor eax,eax
	out dx,al
	inc edx
	out dx,al
	mov al,63
	out dx,al
	out dx,al
	retn

	ALIGN 4
frameWaitFuncTab:
	dd waitVblankNoRasterBar, waitVblankRasterBar
	dd waitPitTimerNoRasterBar, waitPitTimerRasterBar

	ALIGN 4
_Video_WaitForVblank PROC NEAR
	push eax
	push edx
	movzx eax,byte ptr _vblankPitTimerEnabled
	shl eax,1
	or al,_showRasterBars
	call [frameWaitFuncTab+eax*4]
	pop edx
	pop eax
	call _Mouse_Update
	retn
_Video_WaitForVblank ENDP

	ALIGN 4
	; result -> eax
DoVblankMeasure PROC NEAR
	mov dx,3DAh
	; ----------------------
	; wait for retrace
	; ----------------------
L0:	in al,dx
	test al,8
	jnz L0
L1:	in al,dx
	test al,8
	jz L1
	; ----------------------
	; start PIT timer (channel 0, mode 2)
	; ----------------------
	mov al,34h
	out 43h,al
	xor al,al
	out 40h,al
	out 40h,al
	; ----------------------
	; wait for retrace
	; ----------------------
L2:	in al,dx
	test al,8
	jnz L2
L3:	in al,dx
	test al,8
	jz L3
	; ----------------------
	; read PIT count (channel 0, mode 0)
	; ----------------------
	xor al,al
	out 43h,al
	in al,40h
	mov ah,al
	in al,40h
	xchg al,ah
	neg ax
	movzx eax,ax
	; ----------------------
	retn
DoVblankMeasure ENDP

MAX_ITERATIONS	EQU 10

	ALIGN 4
_Video_MeasureVblankPitTicks PROC NEAR
	pushad
	cli
	; ----------------------
	; this test has been modified to give slightly more accurate results
	; ----------------------
	mov ebp,MAX_ITERATIONS
L4:	call DoVblankMeasure
	push eax
	call DoVblankMeasure
	pop ebx				; ebx = test1, eax = test2
	mov ecx,ebx
	sub ecx,ebx
	jns L5
	neg ecx				; ecx = ABS(test1-test2)
L5:	cmp ecx,2
	jbe L6				; difference is <= 2, we're good
	dec ebp
	jnz L4
	; no good values found, use the average of last two values
	add eax,ebx
	shr eax,1
L6:	; ----------------------
	mov ebx,eax
	; ----------------------
	; restore PIT channel 0 back to default (BIOS timer)
	; ----------------------
	mov al,36h
	out 43h,al
	xor al,al
	out 40h,al
	out 40h,al
	; ----------------------
	mov eax,ebx
	; ----------------------
	cmp ax,20572			; max (round[PIT_CLK / 58.0])
	ja LErr
	cmp ax,19245			; min (round[PIT_CLK / 62.0])
	jb LErr
	jmp L7
LErr:	mov ax,19906			; nominal (round[PIT_CLK / 59.9405])
L7:	mov _vblankPitTicks,ax
	mov bx,ax
	mov cx,ax
	; ----------------------
	mov ax,bx
	shr ax,7
	sub bx,ax
	mov vblankPitTicks128,bx 	; vblankPitTicks - (vblankPitTicks/128)
	; ---------------------
	mov ax,cx
	shr ax,4
	sub cx,ax
	mov vblankPitTicks16,cx		; vblankPitTicks - (vblankPitTicks/16)
	; ----------------------
	; calculate vblank-wait timeout value
	; ----------------------
	mov dx,3DAh
L1x:	in al,dx
	test al,8
	jz L1x
L2x:	in al,dx
	test al,8
	jnz L2x
	mov ecx,65535
L3x:	in al,dx
	test al,1
	jnz L3x
L4x:	in al,dx
	test al,1
	jz L4x
L5x:	in al,dx
	test al,1
	loopnz L5x
	neg cx
	add cx,2
	add cx,cx
	movzx ecx,cx
	mov vblankPitTimeout,ecx
	; ----------------------
	popad
	sti
	retn
_Video_MeasureVblankPitTicks ENDP

	ALIGN 4
vblankPitTimeout	dd 0
vblankPitTicks16	dw 0
vblankPitTicks128	dw 0
videoFrameTest		db 0

END
