#ifndef __DMA_H__
#define __DMA_H__

#include <stdint.h>
#include <stdbool.h>

enum
{
	DMA_DONT_PAUSE_IRQS	= 0,
	DMA_PAUSE_IRQS		= 1
};

#define DMA_MODE_WRITE     0x04
#define DMA_MODE_READ      0x08
#define DMA_MODE_AUTOINIT  0x10
#define DMA_MODE_DECREMENT 0x20
#define DMA_MODE_SINGLE    0x40
#define DMA_MODE_BLOCK     0x80

typedef struct
{
	uint8_t addr, count, page, mask, mode, flipflop, request, clear;
} dmaports_t;

bool DMA_Init(uint8_t channel, uint16_t length, uint8_t mode);
void DMA_Stop(uint8_t channel);
bool DMA_Close(uint8_t channel);
bool DMA_Start(uint8_t channel, bool pauseIRQs);
void *DMA_GetBuffer(uint8_t channel);
uint16_t DMA_GetPosition(uint8_t channel);

#endif
