#ifndef __MOUSE_H__
#define __MOUSE_H__

#include <stdint.h>
#include <stdbool.h>

#define POINTER_W 8
#define POINTER_H 13

typedef struct
{
	// order is important for amouse.asm
	int32_t x, y;
	bool leftButtonDown, rightButtonDown, clickHandled;
	// -----------------------
	bool blockInput;
} mouse_t;

extern mouse_t mouse;

void Mouse_SetupGUIButtonRepeat(uint16_t x1, uint16_t x2, uint16_t y1, uint16_t y2, void (*callback)(), uint8_t initialDelay, uint8_t delayDuration);
void Mouse_HandleButtonRepeat(void);
void Mouse_SetDiskAccessColor(void);
void Mouse_UpdateColor(void);
void Mouse_Error(void);
bool Mouse_Initialize(void);
void Mouse_Close(void);
void Mouse_HandleInput(void);

// amouse.asm
extern void Mouse_Update(void);

#endif
