#ifndef __SAMPLER_H__
#define __SAMPLER_H__

#include <stdint.h>
#include <stdbool.h>
#include "audio/replayer.h"

typedef struct sampler_t
{
	int8_t *samStart;
	int32_t samOffset, samDisplay, samLength, samplePos;
	int32_t loopStartPos, loopEndPos;
	int32_t dragStart, dragEnd;
	int32_t markStartOfs, markEndOfs, markStart, markEnd;
} sampler_t;

extern sampler_t sampler; // sampler.c

bool Sampler_Init(void);
void Sampler_Free(void);
bool Sampler_AllocateSampleData(ptSmp_t *s, int32_t lengthInBytes);
void Sampler_FreeSampleData(ptSmp_t *s);
void Sampler_SetLoopStartFromX(ptSmp_t *s, int32_t x, int32_t oldLoopEnd);
void Sampler_SetLoopEndFromX(ptSmp_t *s, int32_t x);
void Sampler_EraseOldSamplingLine(void);
void Sampler_WriteSamplingLine(void);
void Sampler_MarkToOffset(void);
void Sampler_OffsetToMark(void);
void Sampler_SetLoopSprites(void);
void Sampler_DisplaySample(void);
void Sampler_DrawDragBar(void);
void Sampler_ShowSampleInfo(void);
void Sampler_RedrawWaveform(void);
void Sampler_Toggle(void);

#endif
